// bgsviewDoc.cpp : CBgsviewDoc NX̓̒`s܂B
//

#include "stdafx.h"
#include "bgsview.h"

#include "bgsviewDoc.h"
#include "mainfrm.h"

#include "conv.h"
#include "scdata.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBgsviewDoc

IMPLEMENT_DYNCREATE(CBgsviewDoc, CDocument)

BEGIN_MESSAGE_MAP(CBgsviewDoc, CDocument)
	//{{AFX_MSG_MAP(CBgsviewDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBgsviewDoc NX̍\z/

CBgsviewDoc::CBgsviewDoc()
{
	m_maxNorth = m_minNorth = m_maxEast = m_minEast = 0.0;
	m_selRefPoint = NULL;
	m_selRefLine = -1;
}

CBgsviewDoc::~CBgsviewDoc()
{
}

BOOL CBgsviewDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: ̈ʒuɍďǉĂB
	// (SDI hLg͂̃hLgėp܂B)

	return TRUE;
}

void CBgsviewDoc::DeleteContents() 
{
	CRefPoint *refp;
	
	POSITION pos = m_refpList.GetHeadPosition();
	if (pos) {
		while(1) {
			refp = m_refpList.GetNext(pos);
			if (!pos) break;

			delete refp;
		}
	}

	m_refpList.RemoveAll();

	m_maxNorth = m_minNorth = m_maxEast = m_minEast = 0.0;
	m_selRefPoint = NULL;
	m_selRefLine = -1;
	
	CDocument::DeleteContents();
}

/////////////////////////////////////////////////////////////////////////////
// CBgsviewDoc VAC[[V

void CBgsviewDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: ̈ʒuɕۑp̃R[hǉĂB
	}
	else
	{
		// TODO: ̈ʒuɓǂݍݗp̃R[hǉĂB
	}
}

/////////////////////////////////////////////////////////////////////////////
// CBgsviewDoc NX̐ff

#ifdef _DEBUG
void CBgsviewDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CBgsviewDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBgsviewDoc R}h

static char pLine[1024];	// line buffer
static CString token[300];	// token

BOOL CBgsviewDoc::OnOpenDocument(LPCTSTR lpszPathName)
{
	CStdioFile	file;
	CRefPoint	*refp;

	DeleteContents();

	if (!file.Open(lpszPathName, CFile::modeRead)) {
		TRACE("can't  open file\n");
		return FALSE;
	}

	m_nLineNum = 0;

	int n;

	while (file.ReadString(pLine, 256)) {
		m_nLineNum ++;

		n = SplitLine(pLine, token, 20);
		if (n <= 0) continue;

		// renge
		if (token[0] == "MaxNorth") {
			m_maxNorth = degs2rad(token[1]);
		}
		else if (token[0] == "MinNorth") {
			m_minNorth = degs2rad(token[1]);
		}
		else if (token[0] == "MaxEast") {
			m_maxEast = degs2rad(token[1]);
		}
		else if (token[0] == "MinEast") {
			m_minEast = degs2rad(token[1]);
		}

		// refp
		else if (token[0].Find("RefPoint") == 0) {
			//TRACE("\nline %d: RefPoint %s %s %s\n", m_nLineNum,
			//	token[1], token[2], token[4]);
			refp = new CRefPoint;
			refp->SetLatLon(token[1], token[2]);
			refp->SetScale(atof(token[4]));
			refp->SetLineNum(m_nLineNum);
			m_refpList.AddTail(refp);
		}

		else if (token[0] == "RotatedCall") {
			refp->SetRotate(atof(token[3]));
		}

		else if (token[0] == "Building") {
			//Building 0 0 0 3 150 100 1
			int ns = atoi(token[5]) / 2;
			int ew = atoi(token[6]) / 2;
			refp->AddMoveTo(-ns, -ew, 0);
			refp->AddDrawTo(-ns,  ew, 0);
			refp->AddDrawTo( ns,  ew, 0);
			refp->AddDrawTo( ns, -ew, 0);
			refp->AddDrawTo(-ns, -ew, 0);
		}

		// points
		else if (token[0] == "Points" ||
			token[0] == "VecPoints") {
			refp->SetPointsOrigin(atoi(token[1]));
			ReadPoints(&file, refp);
		}

		// MoveToPt
		else if (token[0] == "MoveToPt") {
			refp->AddMoveToPt(atoi(token[1]));
		}
		else if (token[0] == "DrawToPt") {
			refp->AddDrawToPt(atoi(token[1]));
		}
		else if (token[0] == "MoveTo") {
			refp->AddMoveTo(atoi(token[1]), atoi(token[3]), atoi(token[2]));
		}
		else if (token[0] == "DrawTo" ||
			token[0] == "LineTo") {
			refp->AddDrawTo(atoi(token[1]), atoi(token[3]), atoi(token[2]));
		}
		else if (token[0] == "3DPoly" ||
			token[0] == "ShadedPoly") {
			Read3DPoly(&file, refp);
		}
		else if (token[0] == "DotLine") {
			refp->AddMoveTo(atoi(token[1]), atoi(token[3]), atoi(token[2]));
			refp->AddDrawTo(atoi(token[4]), atoi(token[6]), atoi(token[5]));
		}
	}
	
	UpdateAllViews(NULL);
	return TRUE;
}

void CBgsviewDoc::ReadPoints(CStdioFile *file, CRefPoint *refp)
{
	refp->DeletePoints();

	int n;
	while (file->ReadString(pLine, 256)) {
		m_nLineNum++;

		n = SplitLine(pLine, token, 5);
		if (n <= 0) continue;

		if (token[0] == '/') break;

		refp->AddPoint(atof(token[0]), atof(token[2]), atof(token[1]));
	}
}

void CBgsviewDoc::Read3DPoly(CStdioFile *file, CRefPoint *refp)
{
	int n;
	BOOL firstflag = TRUE;
	int firstPoint = -1;
	char c;
	int i;

	while (file->ReadString(pLine, 1024)) {
		m_nLineNum++;

		n = SplitLine(pLine, token, 1024);

		for (i=0; i<n; i++) {
			c = token[i][0];
			if (c == '/') goto end;
			if (c < '0' || c > '9') {
				TRACE("Error in line %d\n", m_nLineNum);
				goto end;
			}
					
			if (firstflag) {
				firstPoint = atoi(token[i]);
				refp->AddMoveToPt(firstPoint);
				firstflag = FALSE;
			} else {
				refp->AddDrawToPt(atoi(token[i]));
			}
		}
	}
end:
	if (firstPoint >= 0)
		refp->AddDrawToPt(firstPoint);

	return;
}

int CBgsviewDoc::SplitLine(char *line, CString token[], int n)
{
	int i = 0;
	char *p;
	char *p1;

#define	IS_SPACE(c)	((c) == ' ' || (c) == '\t' || (c) == '\n')

	p1 = NULL;

	for (p = line; *p; p++) {
		if (p1 == NULL) {
			if (!IS_SPACE(*p)) {
				p1 = p;
			}
		}
		else {
			if (IS_SPACE(*p)) {
				*p = '\0';
				token[i] = p1;
				p1 = NULL;
				i++;
				if (i >= n) break;
			}
		}
	}

	return i;
}
void CBgsviewDoc::GetInitialOrgLatLon(double *lat, double *lon)
{
	*lat = m_maxNorth;
	*lon = m_minEast;
}

// `
void CBgsviewDoc::DrawAll(CDC *pDC, double orgLat, double orgLon, double meterPerPixel)
{
	CRefPoint *refp;
	
	POSITION pos = m_refpList.GetHeadPosition();
	if (!pos) return;
	
	while(1) {
		refp = m_refpList.GetNext(pos);
		if (!pos) break;

		if (refp == m_selRefPoint) {
			refp->Draw(pDC, orgLat, orgLon, meterPerPixel, TRUE);
		} else {
			refp->Draw(pDC, orgLat, orgLon, meterPerPixel, FALSE);
		}
	}
}


void CBgsviewDoc::SelRefPoint(double lat, double lon)
{
	POSITION pos = m_refpList.GetHeadPosition();
	if (!pos) return;
	double mindist = 1000000.0, dist;
	CRefPoint *refp;

	while (1) {
		refp = m_refpList.GetNext(pos);
		if (!pos) break;
		
		dist = refp->CalcMinDist(lat, lon);
		if (dist < mindist) {
			mindist = dist;
			m_selRefPoint = refp;
			m_selRefLine = refp->GetLineNum();
		}
	}
	if (m_selRefLine >= 0) {
		char str[20];
		sprintf(str, "%d", m_selRefLine);
		((CMainFrame *)AfxGetMainWnd())->SetLineNumStatus(str);
	}
}
